"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



ApplicationModel subclass:#UISelectionPanel
	instanceVariableNames:'userClass userSpecs userLabels majorSelection clipBoardSpec'
	classVariableNames:'UserClass UserSpecs UserLabels'
	poolDictionaries:''
	category:'Interface-UIPainter'
!

Object subclass:#UserDefinedGallery
	instanceVariableNames:''
	classVariableNames:'LabelList SelectorList HolderList NextUniqueNumber'
	poolDictionaries:''
	privateIn:UISelectionPanel
!

!UISelectionPanel class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


!

documentation
"
    implements a selection panel, keeping widgets which could be placed
    into the UIPainter by drag & drop.

    [start with:]
        UISelectionPanel open

    [author:]
        Claus Gittinger
        Claus Atzkern

    [see also:]
        TabView
        NoteBookView
        UIGalleryView
        UIPainter

"

! !

!UISelectionPanel class methodsFor:'initialization'!

initialize
    super initialize.
    UserClass  := UISelectionPanel::UserDefinedGallery.
    UserSpecs  := #listOfSelectors.
    UserLabels := #listOfLabels.

    "Modified: / 8.12.1997 / 18:53:06 / cg"
! !

!UISelectionPanel class methodsFor:'accessing'!

specifications

    ^ #(
        #( 'Standard'  #( 
                            #('Buttons' standardButtons)
                            #('Menus'   standardMenus)
                            #('Text'    standardTexts)
                            #('Lists'   standardLists)
                            #('Groups'  standardGroups)
                            #('Misc'    standardMisc)
                         )
         )

        #( 'Clipboard'  #(
                            #('Copy & Paste Buffer'     clipBoardSpec)
                          )
         )

        #( 'User Def.'   #userDefined )
     )

    "Modified: / 21.4.1998 / 12:04:22 / cg"
!

userClass
    "return the class which provides the user defined gallery specs."

    ^ UserClass

    "Created: / 5.12.1997 / 15:12:50 / cg"
!

userClass:aClass specSelector:aSpecAccessSelector labelSelector:aLabelListAccessSelector
    "change the class which provides the user defined gallery specs."

    UserClass := aClass.
    UserSpecs := aSpecAccessSelector.
    UserLabels := aLabelListAccessSelector.

    "
     UISelectionPanel 
        userClass:UISelectionPanel::VariableUserDefinedGallery
        specSelector:#listOfSelectors
        labelSelector:#listOfLabels
    "

    "Modified: / 5.12.1997 / 13:54:47 / cg"
    "Created: / 5.12.1997 / 13:56:10 / cg"
! !

!UISelectionPanel class methodsFor:'interface specification'!

nameAndSelectorSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#nameAndSelectorSpec
     UISelectionPanel new openInterface:#nameAndSelectorSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'uIPainterView'
              #layout: #(#LayoutFrame 110 0 366 0 424 0 581 0)
              #label: 'Painter'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 110 366 425 582)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#LabelSpec
                    #name: 'title'
                    #layout: #(#Point 5 10)
                    #label: 'Class & selectors to access user specs:'
                    #adjust: #left
                    #resizeForLabel: true
                )
                 #(#LabelSpec
                    #name: 'classLabel'
                    #layout: #(#AlignmentOrigin 68 0.11 51 0 1 0.5)
                    #label: 'Class:'
                    #adjust: #right
                    #resizeForLabel: true
                )
                 #(#InputFieldSpec
                    #name: 'classField'
                    #layout: #(#LayoutFrame 74 0.11 39 0 -5 1.0 61 0)
                    #tabable: true
                    #model: #className
                    #type: #string
                )
                 #(#LabelSpec
                    #name: 'labelsLabel'
                    #layout: #(#AlignmentOrigin 68 0.11 74 0 1 0.5)
                    #label: 'Labels:'
                    #adjust: #right
                    #resizeForLabel: true
                )
                 #(#InputFieldSpec
                    #name: 'labelsField'
                    #layout: #(#LayoutFrame 74 0.11 64 0 -5 1.0 86 0)
                    #tabable: true
                    #model: #labelsKey
                    #type: #symbolOrNil
                )
                 #(#LabelSpec
                    #name: 'specsLabel'
                    #layout: #(#AlignmentOrigin 68 0.11 99 0 1 0.5)
                    #label: 'Specifications:'
                    #adjust: #right
                    #resizeForLabel: true
                )
                 #(#InputFieldSpec
                    #name: 'specsField'
                    #layout: #(#LayoutFrame 74 0.11 89 0 -5 1.0 111 0)
                    #tabable: true
                    #model: #specsKey
                    #type: #symbolOrNil
                )
                 #(#HorizontalPanelViewSpec
                    #name: 'commitPanel'
                    #layout: #(#LayoutFrame 0 0.0 -23 1.0 0 1.0 0 1.0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#ActionButtonSpec
                              #name: 'cancel'
                              #label: 'cancel'
                              #tabable: true
                              #model: #cancel
                              #extent: #(#Point 153 23)
                          )
                           #(#ActionButtonSpec
                              #name: 'accept'
                              #label: 'ok'
                              #tabable: true
                              #model: #accept
                              #isDefault: true
                              #extent: #(#Point 153 23)
                          )
                        )
                    )
                    #horizontalLayout: #fitSpace
                    #verticalLayout: #fit
                    #horizontalSpace: 3
                    #verticalSpace: 3
                )
                 #(#CheckBoxSpec
                    #name: 'updateDefaultResources'
                    #layout: #(#Point 5 133)
                    #model: #updateDefaultResources
                    #label: 'Update Default Resources'
                )
              )
          )
      )
!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#windowSpec
     UISelectionPanel new openInterface:#windowSpec
     UISelectionPanel open
    "

    <resource: #canvas>

    ^

       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Widget Gallery'
              #layout: #(#LayoutFrame 134 0 100 0 654 0 382 0)
              #label: 'Widget Gallery'
              #min: #(#Point 100 280)
              #max: #(#Point 1160 870)
              #bounds: #(#Rectangle 134 100 655 383)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#UIGalleryViewSpec
                    #name: 'gallery'
                    #layout: #(#LayoutFrame 0 0.0 0 0.0 -40 1.0 0 1.0)
                    #tabable: true
                    #model: #galleryModel
                    #menu: #galleryList
                    #useIndex: true
                    #minorKeys: #minorKeys
                    #clientSpec: #clientSpec
                    #raiseMenu: #raiseMenu
                )
                 #(#TabViewSpec
                    #name: 'major'
                    #layout: #(#LayoutFrame -40 1.0 30 0.0 0 1.0 0 1.0)
                    #model: #majorChannel
                    #menu: #majorList
                    #direction: #right
                    #useIndex: true
                )
              )
          )
      )

    "Modified: / 5.9.1998 / 17:43:14 / cg"
! !

!UISelectionPanel class methodsFor:'menus'!

menuSelected

    <resource: #menu>

    ^ #(#Menu #(
                #(#MenuItem
                        #'label:' 'copy'
                        #'value:' #copy
                 )
                #(#MenuItem
                        #'label:' 'cut'
                        #'value:' #cut
                 )
                )
               nil
               nil
        )

    "Modified: / 29.10.1997 / 03:20:30 / cg"
!

menuUnselected
    <resource: #menu>

    ^ #(#Menu #(
                #(#MenuItem
                        #'label:' 'paste'
                        #'value:' #paste
                 )
                )
               nil
               nil
        )

    "Modified: / 29.10.1997 / 03:20:38 / cg"
! !

!UISelectionPanel class methodsFor:'standard specifications'!

standardButtons
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardButtons
     UISelectionPanel new openInterface:#standardButtons
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Buttons'
              #layout: #(#LayoutFrame 39 0 189 0 517 0 392 0)
              #label: 'Buttons'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 39 189 518 393)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#ActionButtonSpec
                    #name: 'Button'
                    #layout: #(#LayoutFrame 15 0 15 0 140 0 37 0)
                    #label: 'Button'
                    #translateLabel: true
                )
                 #(#ActionButtonSpec
                    #name: 'Button - OK'
                    #layout: #(#LayoutFrame 15 0 47 0 140 0 69 0)
                    #label: 'OK'
                    #translateLabel: true
                    #model: #accept
                )
                 #(#ActionButtonSpec
                    #name: 'Button - Cancel'
                    #layout: #(#LayoutFrame 15 0 79 0 140 0 101 0)
                    #label: 'Cancel'
                    #translateLabel: true
                    #model: #cancel
                )
                 #(#ActionButtonSpec
                    #name: 'Button - Help'
                    #layout: #(#LayoutFrame 15 0 111 0 140 0 133 0)
                    #label: 'Help'
                    #translateLabel: true
                    #model: #help
                )
                 #(#ActionButtonSpec
                    #name: 'Button - Close'
                    #layout: #(#LayoutFrame 15 0 143 0 140 0 165 0)
                    #label: 'Close'
                    #translateLabel: true
                    #model: #closeRequest
                )
                 #(#ToggleSpec
                    #name: 'Toggle'
                    #layout: #(#LayoutFrame 157 0 15 0 293 0 37 0)
                    #label: 'Toggle'
                    #isTriggerOnDown: true
                    #translateLabel: true
                    #lampColor: #(#Color 100.0 100.0 0.0)
                )
                 #(#RadioButtonSpec
                    #name: 'Radio Button'
                    #layout: #(#LayoutFrame 157 0.0 47 0 293 0 69 0)
                    #label: 'Radio Button'
                    #isTriggerOnDown: true
                    #translateLabel: true
                    #lampColor: #(#Color 100.0 100.0 0.0)
                )
                 #(#CheckBoxSpec
                    #name: 'Check Box'
                    #layout: #(#LayoutFrame 157 0 79 0 293 0 101 0)
                    #translateLabel: true
                    #label: 'Check Box'
                )
                 #(#CheckToggleSpec
                    #name: 'Check Toggle'
                    #layout: #(#LayoutOrigin 157 0 113 0)
                    #isTriggerOnDown: true
                    #showLamp: false
                    #lampColor: #(#Color 100.0 100.0 0.0)
                )
                 #(#LabelSpec
                    #name: 'CheckToggleLabel'
                    #layout: #(#AlignmentOrigin 183 0 112 0 0 0)
                    #label: 'Check Toggle'
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#ButtonSpec
                    #name: 'Model Button'
                    #layout: #(#LayoutFrame 309 0 15 0 445 0 37 0)
                    #label: 'Model Button'
                    #translateLabel: true
                )
                 #(#LabelSpec
                    #name: 'UpDownButtonLabel'
                    #layout: #(#AlignmentOrigin 361 0 49 0 0 0)
                    #label: 'Spin Button'
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#UpDownButtonSpec
                    #name: 'UpDown Button'
                    #layout: #(#LayoutFrame 309 0 47 0 354 0 69 0)
                    #orientation: #horizontal
                )
                 #(#LabelSpec
                    #name: 'ArrowButtonsLabel'
                    #layout: #(#AlignmentOrigin 361 0 83 0 0 0)
                    #label: 'Arrow Button'
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#ArrowButtonSpec
                    #name: 'Arrow Button'
                    #layout: #(#LayoutFrame 309 0 79 0 331 0 101 0)
                    #isTriggerOnDown: true
                    #direction: #right
                )
              )
          )
      )

    "Modified: / 20.5.1998 / 03:25:21 / cg"
!

standardGraphs
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardGraphs
     UISelectionPanel new openInterface:#standardGraphs
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Graphs'
              #layout: #(#LayoutFrame 114 0 373 0 583 0 615 0)
              #label: 'Graphs'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 114 373 584 616)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#GraphColumnView2DSpec
                    #name: 'GraphColumnView2D'
                    #layout: #(#LayoutFrame 15 0 15 0 220 0 110 0)
                    #gridX: 0
                    #gridY: 0
                )
                 #(#LabelSpec
                    #name: 'GraphColumnView2DLabel'
                    #layout: #(#AlignmentOrigin 19 0 19 0 0 0)
                    #label: 'GraphColumnViewView2D'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#GraphColumnView3DSpec
                    #name: 'GraphColumnView3D'
                    #layout: #(#LayoutFrame 240 0 15 0 445 0 110 0)
                )
                 #(#LabelSpec
                    #name: 'GraphColumnView3DLabel'
                    #layout: #(#AlignmentOrigin 244 0 19 0 0 0)
                    #label: 'GraphColumnViewView3D'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
              )
          )
      )
!

standardGroups
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardGroups
     UISelectionPanel new openInterface:#standardGroups
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Groups'
              #layout: #(#LayoutFrame 147 0 281 0 647 0 520 0)
              #label: 'Groups'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 147 281 648 521)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#ViewSpec
                    #name: 'Box'
                    #layout: #(#LayoutFrame 15 0 15 0 220 0 110 0)
                )
                 #(#LabelSpec
                    #name: 'ViewLabel'
                    #layout: #(#AlignmentOrigin 18 0 17 0 0 0)
                    #label: 'Box'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'VPanelLabel'
                    #layout: #(#LayoutFrame 15 0 116 0 220 0 139 0)
                    #label: 'Variable Panels'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#VariableHorizontalPanelSpec
                    #name: 'Variable Horizontal Panel'
                    #layout: #(#LayoutFrame 15 0 140 0 110 0 230 0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#LabelSpec
                              #name: 'label4'
                              #label: 'A'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label5'
                              #label: 'B'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #canUIDrag: false
                          )
                        )
                    )
                    #handles: #(#Any 0.5 1.0)
                )
                 #(#VariableVerticalPanelSpec
                    #name: 'Variable Vertical Panel'
                    #layout: #(#LayoutFrame 125 0 140 0 220 0 230 0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#LabelSpec
                              #name: 'label9'
                              #label: 'A'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label10'
                              #label: 'B'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #canUIDrag: false
                          )
                        )
                    )
                    #handles: #(#Any 0.5 1.0)
                )
                 #(#FramedBoxSpec
                    #name: 'Framed Box'
                    #layout: #(#LayoutFrame 240 0 15 0 445 0 110 0)
                    #label: 'Framed Box'
                    #labelPosition: #topLeft
                    #translateLabel: true
                )
                 #(#LabelSpec
                    #name: 'PanelLabel'
                    #layout: #(#LayoutFrame 240 0 116 0 445 0 139 0)
                    #label: 'Panels'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#HorizontalPanelViewSpec
                    #name: 'Horizontal Panel'
                    #layout: #(#LayoutFrame 240 0 140 0 324 0 230 0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#LabelSpec
                              #name: 'label1'
                              #label: 'A'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label2'
                              #label: 'B'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label3'
                              #label: 'C'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                        )
                    )
                    #horizontalLayout: #center
                    #verticalLayout: #center
                    #horizontalSpace: 3
                    #verticalSpace: 3
                )
                 #(#VerticalPanelViewSpec
                    #name: 'Vertical Panel'
                    #layout: #(#LayoutFrame 332 0 140 0 379 0 230 0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#LabelSpec
                              #name: 'label6'
                              #label: 'A'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label7'
                              #label: 'B'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label8'
                              #label: 'C'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                        )
                    )
                    #horizontalLayout: #center
                    #verticalLayout: #center
                    #horizontalSpace: 3
                    #verticalSpace: 3
                )
                 #(#PanelViewSpec
                    #name: 'Panel'
                    #layout: #(#LayoutFrame 387 0 140 0 445 0 230 0)
                    #component: 
                     #(#SpecCollection
                        #collection: 
                         #(
                           #(#LabelSpec
                              #name: 'label11'
                              #label: 'A'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label12'
                              #label: 'B'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label13'
                              #label: 'C'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label14'
                              #label: 'D'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                           #(#LabelSpec
                              #name: 'label15'
                              #label: 'E'
                              #style: #(#FontDescription #helvetica #medium #roman 12)
                              #level: 2
                              #extent: #(#Point 23 23)
                              #canUIDrag: false
                          )
                        )
                    )
                    #horizontalLayout: #fitSpace
                    #verticalLayout: #fitSpace
                    #horizontalSpace: 3
                    #verticalSpace: 3
                )
              )
          )
      )

    "Modified: / 20.5.1998 / 03:26:08 / cg"
!

standardLists
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardLists
     UISelectionPanel new openInterface:#standardLists
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Lists'
              #layout: #(#LayoutFrame 164 0 52 0 633 0 294 0)
              #label: 'Lists'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 164 52 634 295)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#SequenceViewSpec
                    #name: 'List'
                    #layout: #(#LayoutFrame 15 0 30 0 220 0 110 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                    #useIndex: false
                )
                 #(#LabelSpec
                    #name: 'ListLabel'
                    #layout: #(#AlignmentOrigin 15 0 30 0 0 1)
                    #label: 'List'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#SelectionInTreeViewSpec
                    #name: 'Tree List'
                    #layout: #(#LayoutFrame 15 0 145 0 220 0 225 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'TreeListLabel'
                    #layout: #(#AlignmentOrigin 15 0 145 0 0 1)
                    #label: 'Tree List'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#DataSetSpec
                    #name: 'Table'
                    #layout: #(#LayoutFrame 240 0 30 0 445 0 110 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'TableLabel'
                    #layout: #(#AlignmentOrigin 240 0 30 0 0 1)
                    #label: 'Table'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#FileSelectionTreeSpec
                    #name: 'File Tree List'
                    #layout: #(#LayoutFrame 240 0 145 0 445 0 225 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'FileTreeListLabel'
                    #layout: #(#AlignmentOrigin 240 0 145 0 0 1)
                    #label: 'File Tree List'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
              )
          )
      )

    "Modified: / 21.4.1998 / 20:36:36 / cg"
!

standardMenus
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardMenus
     UISelectionPanel new openInterface:#standardMenus
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Menus'
              #layout: #(#LayoutFrame 110 0 120 0 586 0 342 0)
              #level: 0
              #label: 'Menus'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 110 120 587 343)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#MenuPanelSpec
                    #name: 'Tool Bar'
                    #layout: #(#LayoutFrame 15 0 146 0 140 0 178 0)
                    #textDefault: true
                )
                 #(#LabelSpec
                    #name: 'ToolBarLabel'
                    #layout: #(#AlignmentOrigin 15 0 146 0 0 1)
                    #label: 'Tool Bar'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#MenuPanelSpec
                    #name: 'Menu Bar'
                    #layout: #(#LayoutFrame 15 0 196 0 140 0 218 0)
                )
                 #(#LabelSpec
                    #name: 'MenuBarLabel'
                    #layout: #(#AlignmentOrigin 15 0 195 0 0 1)
                    #label: 'Menu Bar'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#PopUpListSpec
                    #name: 'PopUp List'
                    #layout: #(#LayoutFrame 15 0 15 0 140 0 37 0)
                    #label: 'PopUp List'
                    #useIndex: false
                )
                 #(#ComboListSpec
                    #name: 'Combo List'
                    #layout: #(#LayoutFrame 15 0 45 0 140 0 65 0)
                    #useIndex: false
                )
                 #(#LabelSpec
                    #name: 'ComboListLabel'
                    #layout: #(#AlignmentOrigin 17 0 65 0 0 1)
                    #label: 'Combo List'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#ComboBoxSpec
                    #name: 'Combo Box'
                    #layout: #(#LayoutFrame 15 0 73 0 140 0 93 0)
                )
                 #(#LabelSpec
                    #name: 'ComboBoxLabel'
                    #layout: #(#AlignmentOrigin 17 0 93 0 0 1)
                    #label: 'Combo Box'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#ExtendedComboBoxSpec
                    #name: 'Extended Combo Box'
                    #layout: #(#LayoutFrame 15 0 100 0 140 0 120 0)
                    #adjustRight: true
                )
                 #(#LabelSpec
                    #name: 'ExtendedComboBoxLabel'
                    #layout: #(#AlignmentOrigin 18 0 120 0 0 1)
                    #label: 'Extended Combo'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#TabViewSpec
                    #name: 'Tab Header'
                    #layout: #(#LayoutFrame 157 0 15 0 292 0 51 0)
                )
                 #(#NoteBookViewSpec
                    #name: 'Note Book'
                    #layout: #(#LayoutFrame 157 0 58 0 292 0 150 0)
                )
                 #(#UIGalleryViewSpec
                    #name: 'Gallery'
                    #layout: #(#LayoutFrame 309 0 15 0 445 0 150 0)
                )
              )
          )
      )
!

standardMisc
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardMisc
     UISelectionPanel new openInterface:#standardMisc
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Misc'
              #layout: #(#LayoutFrame 50 0 73 0 517 0 357 0)
              #label: 'Misc'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 50 73 518 358)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#ArbitraryComponentSpec
                    #name: 'Arbitrary Component'
                    #layout: #(#LayoutFrame 15 0 15 0 140 0 110 0)
                    #hasBorder: false
                )
                 #(#LabelSpec
                    #name: 'ArbitraryComponentLabel1'
                    #layout: #(#AlignmentOrigin 19 0 19 0 0 0)
                    #label: 'Arbitrary'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'ArbitraryComponentLabel2'
                    #layout: #(#AlignmentOrigin 19 0 43 0 0 0)
                    #label: 'Component'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#UISubSpecification
                    #name: 'SubSpecification'
                    #layout: #(#LayoutFrame 157 0 15 0 292 0 110 0)
                )
                 #(#LabelSpec
                    #name: 'SubSpecificationLabel'
                    #layout: #(#Point 161 19)
                    #label: 'SubSpecification'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#SubCanvasSpec
                    #name: 'SubCanvas'
                    #layout: #(#LayoutFrame 309 0 15 0 445 0 110 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'SubCanvasLabel'
                    #layout: #(#AlignmentOrigin 336 0 19 0 0 0)
                    #label: 'SubCanvas'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'SliderLabel'
                    #layout: #(#AlignmentOrigin 95 0 129 0 1 0)
                    #label: 'Slider'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#SliderSpec
                    #name: 'Slider'
                    #layout: #(#LayoutFrame 100 0 126 0 215 0 144 0)
                    #orientation: #horizontal
                    #step: 1
                )
                 #(#LabelSpec
                    #name: 'ThumbWheelLabel'
                    #layout: #(#AlignmentOrigin 95 0 157 0 1 0)
                    #label: 'Thumb Wheel'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#ThumbWheelSpec
                    #name: 'Thumb Wheel'
                    #layout: #(#LayoutFrame 100 0 152 0 215 0 172 0)
                    #orientation: #horizontal
                    #step: 1
                )
                 #(#LabelSpec
                    #name: 'RegionLabel'
                    #layout: #(#AlignmentOrigin 95 0 189 0 1 0)
                    #label: 'Region'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#RegionSpec
                    #name: 'Region'
                    #layout: #(#LayoutFrame 100 0 183 0 215 0 212 0)
                    #lineWidth: 2
                    #regionType: #ellipse
                )
                 #(#LabelSpec
                    #name: 'SeparatorLabel'
                    #layout: #(#AlignmentOrigin 95 0 219 0 1 0)
                    #label: 'Separator'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#DividerSpec
                    #name: 'Separator'
                    #layout: #(#LayoutFrame 100 0 225 0 215 0 229 0)
                )
                 #(#LabelSpec
                    #name: 'ProgressIndicatorsLabel'
                    #layout: #(#AlignmentOrigin 345 0 129 0 1 0)
                    #label: 'Progress Indicator'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#ProgressIndicatorSpec
                    #name: 'Progress Indicator'
                    #layout: #(#LayoutFrame 350 0 126 0 445 0 144 0)
                )
                 #(#LabelSpec
                    #name: 'RoundProgressIndicatorsLabel'
                    #layout: #(#AlignmentOrigin 345 0 179 0 1 0)
                    #label: 'Round
Progress Indicator'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#RoundProgressIndicatorSpec
                    #name: 'Round Progress Indicator'
                    #layout: #(#LayoutFrame 350 0 148 0 445 0 243 0)
                    #level: 0
                    #borderWidth: 1
                )
              )
          )
      )

    "Modified: / 21.8.1998 / 20:53:14 / cg"
!

standardTexts
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardTexts
     UISelectionPanel new openInterface:#standardTexts
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Texts'
              #layout: #(#LayoutFrame 102 0 279 0 568 0 485 0)
              #label: 'Texts'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 102 279 569 486)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#TextEditorSpec
                    #name: 'Text Editor'
                    #layout: #(#LayoutFrame 15 0 15 0 220 0 110 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'TextEditorLabel'
                    #layout: #(#AlignmentOrigin 53 0 19 0 0 0)
                    #label: 'Text Editor'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#HTMLViewSpec
                    #name: 'HTML Browser'
                    #layout: #(#LayoutFrame 240 0 15 0 445 0 110 0)
                    #hasHorizontalScrollBar: true
                    #hasVerticalScrollBar: true
                )
                 #(#LabelSpec
                    #name: 'HTMLViewLabel'
                    #layout: #(#AlignmentOrigin 267 0 19 0 0 0)
                    #label: 'HTML View'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#InputFieldSpec
                    #name: 'Entry Field'
                    #layout: #(#LayoutFrame 15 0 125 0 220 0 147 0)
                )
                 #(#LabelSpec
                    #name: 'EntryFieldLabel'
                    #layout: #(#AlignmentOrigin 53 0 147 0 0 1)
                    #label: 'Entry Field'
                    #style: #(#FontDescription #helvetica #medium #roman 10)
                    #adjust: #left
                    #resizeForLabel: true
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'Label'
                    #layout: #(#LayoutFrame 240 0 125 0 445 0 147 0)
                    #label: 'Label'
                    #translateLabel: true
                )
              )
          )
      )

    "Modified: / 20.5.1998 / 03:25:40 / cg"
!

standardUserPanel
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:UISelectionPanel andSelector:#standardUserPanel
     UISelectionPanel new openInterface:#standardUserPanel
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'UserPanel'
              #'layout:' #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
              #'label:' 'UserPanel'
              #'bounds:' #(#Rectangle 0 0 445 162)
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#LabelSpec
                    #'name:' 'helpText'
                    #'layout:' #(#Point 10 0)
                    #'labelChannel:' #userDefinedHelpText
                    #'resizeForLabel:' true
                    #'canUIDrag:' false
                )
              )
          )
      )
! !

!UISelectionPanel methodsFor:'actions'!

defineClassAndSelector
    |bd cls sel lbl|

    bd := IdentityDictionary new.
    bd at:#className put:( userClass asValue).
    bd at:#specsKey  put:( (userSpecs  ? '') asValue).
    bd at:#labelsKey put:( (userLabels ? '') asValue).
    bd at:#updateDefaultResources put:(false asValue).

    (self openDialogInterface:#nameAndSelectorSpec withBindings:bd) ifTrue:[
        (      (cls := (bd at:#className) value) notNil
          and:[(sel := (bd at:#specsKey)  value) notNil
          and:[(lbl := (bd at:#labelsKey) value) notNil]]
        ) ifTrue:[
            userClass  := cls.
            userSpecs  := sel.
            userLabels := lbl.

            (bd at:#updateDefaultResources) value ifTrue:[
                UserClass  := userClass.
                UserSpecs  := userSpecs.
                UserLabels := userLabels.
            ]
        ]
    ].
!

paste:something
    "paste something at a point
    "
    |coll specs point device gallery ext spec|

    clipBoardSpec isNil ifTrue:[
        clipBoardSpec := SpecCollection new.
        clipBoardSpec collection:(OrderedCollection new).
    ].
    coll    := clipBoardSpec collection.
    gallery := self builder componentAt:#gallery.
    device  := gallery device.

    point   := device translatePoint:(device pointerPosition)
                                from:(device rootView id)
                                  to:(gallery canvas id).

    point y < 1 ifTrue:[point y:1].
    ext := gallery extent - (10@10).

    (specs := something) isCollection ifFalse:[
        specs := Array with:something
    ].

    specs do:[:aSpec|
        point x > ext x ifTrue:[point x:1].
        point y > ext y ifTrue:[point y:1].

        spec := aSpec copy.
        spec layout:(LayoutOrigin fromPoint:point).
        coll add:spec.
        point := point + (20@20).
    ].
    gallery update.
!

raiseMenu
    "can open menu
    "
    |spec menu value paste|

    spec := self clientSpec value.

    spec notNil ifTrue:[
        menu := self class menuSelected decodeAsLiteralArray.
        self isClipBoard ifFalse:[
            (menu someMenuItemWithValue:#cut) disable.
        ].

        (value := menu startUp) == #cut ifTrue:[
            clipBoardSpec collection remove:spec ifAbsent:nil.
            (self builder componentAt:#gallery) update.
        ] ifFalse:[
            value == #copy ifTrue:[
                self window setSelection:spec
            ]
        ].
      ^ self
    ].

    self isUserBoard ifTrue:[
        ^ self defineClassAndSelector
    ].

    paste := self window getSelection.

    (self canPaste:paste) ifTrue:[
        menu := self class menuUnselected decodeAsLiteralArray.

        (menu startUp) == #paste ifTrue:[
            self paste:paste
        ]
    ].
! !

!UISelectionPanel methodsFor:'aspects'!

clientSpec
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#clientSpec) isNil ifTrue:[
        builder aspectAt:#clientSpec put:(holder :=  ValueHolder new).
        holder addDependent:self.
    ].
    ^ holder
!

clipBoardSpec
    ^ clipBoardSpec
!

galleryList
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#galleryList) isNil ifTrue:[
        builder aspectAt:#galleryList put:(holder :=  ValueHolder new).
    ].
    ^ holder
!

galleryModel
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#galleryModel) isNil ifTrue:[
        builder aspectAt:#galleryModel put:(holder :=  ValueHolder new).
    ].
    ^ holder
!

majorChannel
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#majorChannel) isNil ifTrue:[
        holder := AspectAdaptor new subject:self; forAspect:#majorSelection.
        builder aspectAt:#majorChannel put:holder.
    ].
    ^ holder
!

majorList
    "automatically generated by UIPainter ...
    "
  ^ self class specifications collect:[:el| el first]
!

minorKeys
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#minorKeys) isNil ifTrue:[
        builder aspectAt:#minorKeys put:(holder :=  ValueHolder new).
    ].
    ^ holder
! !

!UISelectionPanel methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "one of my models changed its value
    "
    |channel label topView|

    (channel := self clientSpec) == changedObject ifTrue:[
        topView := builder window topView.

        (label := channel value) notNil ifTrue:[
            topView label:label name, ' '.
        ] ifFalse:[
            topView label:'Widget Gallery '
        ]
    ].

    super update:something with:aParameter from:changedObject.


! !

!UISelectionPanel methodsFor:'drag & drop'!

canDrop:something in:aComponent
    ^ self canPaste:(something collect:[:el| el theObject ]).
!

drop:something in:aComponent at:aPoint

    |spc top|

    top := DragAndDropManager dragOriginatorQuerySignal query topView.

    top == aComponent topView ifTrue:[
        spc := self clientSpec value.
        spc isNil ifTrue:[^ self].

        (clipBoardSpec collection remove:spc ifAbsent:nil) isNil ifTrue:[
            ^ self
        ].
    ] ifFalse:[
        spc := something collect:[:el| el theObject].
    ].
    self paste:spc.

    "Modified: / 18.3.1999 / 18:29:19 / stefan"
! !

!UISelectionPanel methodsFor:'queries'!

canPaste:something
    "returns true if something could be paste
    "
    (self isClipBoard and:[something notNil]) ifTrue:[
        something isCollection ifTrue:[
            something notEmpty ifTrue:[
                ^ (something at:1) isKindOf:UISpecification
            ]
        ] ifFalse:[
            ^ something isKindOf:UISpecification
        ]
    ].
    ^ false

!

isClipBoard
    "returns true if current view is clip board
    "
    majorSelection ~~ 0 ifTrue:[
        ^ (self majorList at:majorSelection) startsWith:'Clip'
    ].
  ^ false
!

isUserBoard
    "returns true if current view is clip board
    "
    majorSelection ~~ 0 ifTrue:[
        ^ (self majorList at:majorSelection) startsWith:'User'
    ].
  ^ false
! !

!UISelectionPanel methodsFor:'selection'!

majorSelection
    ^ majorSelection ? 0
!

majorSelection:aSelection
    |spec g gallery|

    (majorSelection == aSelection or:[aSelection == 0]) ifTrue:[
        ^ self
    ].

    (g := self builder componentAt:#gallery) notNil ifTrue:[
        g builder:nil.
    ].

    majorSelection := aSelection.
    spec := ((self class specifications) at:majorSelection) last.

    gallery := self galleryModel.
    gallery value:0.
    self minorKeys value:nil.

    spec isSymbol ifFalse:[
        self galleryList  value:(spec collect:[:a| a first]).
        self minorKeys setValue:(spec collect:[:a| a last]).
    ] ifTrue:[
        self perform:spec.
    ].
    gallery value:1.

    "Modified: / 21.4.1998 / 11:59:08 / cg"
! !

!UISelectionPanel methodsFor:'startup / release'!

closeRequest
    |sav|

    (sav := masterApplication) notNil ifTrue:[
        masterApplication := nil.
        sav closeRequestFor:(self window).
        masterApplication := sav.
    ] ifFalse:[
        super closeRequest.
    ]

    "Modified: 28.7.1997 / 09:44:40 / cg"
!

initialize
    super initialize.

    userClass  := UserClass.
    userSpecs  := UserSpecs.
    userLabels := UserLabels.

    majorSelection := 0.
!

postOpenWith:aBuilder
    self majorChannel value:1.
! !

!UISelectionPanel methodsFor:'user defined'!

userDefined
    |cls lbl sel builder|

    cls := self resolveName:userClass.

    (cls notNil and:[(cls respondsTo:userLabels)]) ifTrue:[
        lbl := cls perform:userLabels.
        sel := Array new:(lbl size) withAll:#userDefinedSpec.
        self galleryList value:lbl.
        self minorKeys   value:sel.
    ] ifFalse:[
        builder := UIBuilder new isEditing:true.

        builder application:self.
        (self builder componentAt:#gallery) builder:builder. 
        self galleryList value:#( '???' ).
        self minorKeys   value:#( standardUserPanel ).
    ]
!

userDefinedHelpText

^ '
no user defined specifications are configured yet. To assign
user defined specifications to the gallery press the middle
button of your mouse to open a dialog.
'
!

userDefinedSpec
    |cls spc idx|

    cls := self resolveName:userClass.

    (cls notNil and:[(cls respondsTo:userSpecs)]) ifTrue:[
        spc := cls perform:userSpecs.
        idx := self galleryModel value.

        idx <= spc size ifTrue:[
            spc := spc at:idx.
            (cls respondsTo:spc) ifTrue:[
                ^ cls perform:spc
            ]
        ]
    ].
  ^ nil
! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'class initialization'!

initialize
    "initialize my default user-def from the superclasses specs.
     I.e. provide a clocks entry"

    LabelList := self defaultListOfLabels asOrderedCollection.
    SelectorList := self defaultListOfSelectors asOrderedCollection.
    HolderList := OrderedCollection new grow:(SelectorList size).
    NextUniqueNumber := 1.

    UISelectionPanel 
        userClass:self
        specSelector:#listOfSelectors
        labelSelector:#listOfLabels.

    "
     self initialize
    "

    "Modified: / 5.12.1997 / 14:25:22 / cg"
    "Created: / 8.12.1997 / 18:49:42 / cg"
! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'defaults'!

defaultListOfLabels
    ^ #( 'Clocks etc.' 'Business Graphics' )

    "Created: / 8.12.1997 / 18:50:06 / cg"
    "Modified: / 16.6.1998 / 10:20:12 / cg"
!

defaultListOfSelectors
    ^ #( clocksSpec businessGraphicsSpec)

    "Modified: / 5.12.1997 / 14:03:55 / cg"
    "Created: / 8.12.1997 / 18:50:21 / cg"
! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



!

documentation
"
    The standard user-defined selectionPanel entry.
    Here, a single item named 'clocks' is provided, containing
    an analog and digital clock.
    This is a dump example; the actual user-defined panel may be
    extended dynamically.

    Frameworks which provide additional widgets may dynamically
    add more entries, by sending #addUserSpecHolder:label:
    or #removeUserSpecWithLabel:.
    Typically, this is done when a framework is loaded, by one of the
    frameworks class-initialization methods.

    [start with:]
        UISelectionPanel open

    [author:]
        Claus Gittinger
        Claus Atzkern

    [see also:]
        TabView
        NoteBookView
        UIGalleryView
        UIPainter

"


! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'installation / deinstallation'!

addUserSpecHolder:aValueHolder label:aLabelString
    "add a new entry with the given label.
     The specHolder is typically either a spec, a valueHolder or a block.
     In any case, it should return a valid spec from the #value message.
     This spec is installed under that label."

    |syntheticSelector idx|

    syntheticSelector := ('userSpec' , NextUniqueNumber printString) asSymbol.
    NextUniqueNumber := NextUniqueNumber + 1.

    idx := LabelList indexOf:aLabelString.
    idx ~~ 0 ifTrue:[
        SelectorList at:idx put:syntheticSelector.
        HolderList at:idx put:aValueHolder
    ] ifFalse:[
        LabelList addLast:aLabelString.
        SelectorList addLast:syntheticSelector.
        HolderList addLast:aValueHolder
    ]

    "Modified: / 5.12.1997 / 14:13:17 / cg"
    "Created: / 8.12.1997 / 18:50:55 / cg"
!

removeUserSpecWithLabel:aLabelString
    "remove the spec which was previously installed under the given label"

    |idx|

    idx := LabelList indexOf:aLabelString.
    idx ~~ 0 ifTrue:[
        LabelList removeIndex:idx.
        SelectorList removeIndex:idx.
        HolderList removeIndex:idx
    ].

    "Modified: / 5.12.1997 / 14:13:45 / cg"
    "Created: / 8.12.1997 / 18:51:03 / cg"
! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'user defined gallery'!

businessGraphicsSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel::UserDefinedGallery andSelector:#businessGraphicsSpec
     UISelectionPanel::UserDefinedGallery new openInterface:#businessGraphicsSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Interface Builder'
              #layout: #(#LayoutFrame 6 0 582 0 385 0 852 0)
              #label: 'Interface Builder'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 6 582 386 853)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#LabelSpec
                    #name: 'Label2'
                    #layout: #(#LayoutFrame 5 0 5 0 70 0 20 0)
                    #label: 'PieChart'
                    #translateLabel: true
                    #canUIDrag: false
                )
                 #(#PieChartWidgetSpec
                    #name: 'PIE Chart'
                    #layout: #(#LayoutFrame 15 0 21 0 103 0 141 0)
                )
                 #(#LabelSpec
                    #name: 'Label1'
                    #layout: #(#LayoutFrame 16 0.0 146 0 131 0 161 0)
                    #label: 'ChartDescription'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#ChartDescriptionSpec
                    #name: 'Chart Legend'
                    #layout: #(#LayoutFrame 14 0.0 -4 0.656827 14 0.323684 -4 1.0)
                )
                 #(#LabelSpec
                    #name: 'Label3'
                    #layout: #(#LayoutFrame 115 0 5 0 180 0 20 0)
                    #label: 'BarChart'
                    #translateLabel: true
                    #canUIDrag: false
                )
                 #(#BarChartWidgetSpec
                    #name: 'Bar Chart'
                    #layout: #(#LayoutFrame 121 0 21 0 232 0 141 0)
                )
              )
          )
      )
!

clocksSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISelectionPanel::UserDefinedGallery andSelector:#clocksSpec
     UISelectionPanel::UserDefinedGallery new openInterface:#clocksSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'Interface Builder'
              #layout: #(#LayoutFrame 402 0 59 0 781 0 329 0)
              #label: 'Interface Builder'
              #min: #(#Point 10 10)
              #max: #(#Point 1280 1024)
              #bounds: #(#Rectangle 402 59 782 330)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#ArbitraryComponentSpec
                    #name: 'Analog Clock'
                    #layout: #(#LayoutFrame 15 0 39 0 129 0 151 0)
                    #component: #ClockView
                    #hasBorder: false
                )
                 #(#ArbitraryComponentSpec
                    #name: 'Digital Clock'
                    #layout: #(#LayoutOrigin 15 0 176 0)
                    #component: #DigitalClockView
                    #hasBorder: false
                )
                 #(#ArbitraryComponentSpec
                    #name: 'Digital Number display'
                    #layout: #(#LayoutOrigin 142 0 39 0)
                    #component: #DigitalLedDisplay
                    #hasBorder: false
                )
                 #(#LabelSpec
                    #name: 'Label1'
                    #layout: #(#LayoutFrame 15 0 16 0 128 0 38 0)
                    #label: 'Analog Clock'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'Label2'
                    #layout: #(#LayoutFrame 142 0 16 0 270 0 38 0)
                    #label: 'Number Display'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#LabelSpec
                    #name: 'Label3'
                    #layout: #(#LayoutFrame 15 0 155 0 128 0 177 0)
                    #label: 'Digital Clock'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#MeterWidgetSpec
                    #name: 'Meter Widget'
                    #layout: #(#Rectangle 143 101 248 216)
                    #model: #meterValue
                )
                 #(#LabelSpec
                    #name: 'Label4'
                    #layout: #(#LayoutFrame 142 0 74 0 269 0 96 0)
                    #label: 'Meter Widget'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
                 #(#MeterClackCounterSpec
                    #name: 'Meter Clack Counter'
                    #layout: #(#Rectangle 291 40 387 72)
                    #model: #model
                )
                 #(#LabelSpec
                    #name: 'Label5'
                    #layout: #(#LayoutFrame 290 0 16 0 417 0 38 0)
                    #label: 'Meter Clack Counter'
                    #translateLabel: true
                    #adjust: #left
                    #canUIDrag: false
                )
              )
          )
      )
!

listOfLabels
    ^ LabelList

    "Created: / 5.12.1997 / 13:43:03 / cg"
    "Modified: / 8.12.1997 / 18:51:20 / cg"
!

listOfSelectors
    ^ SelectorList

    "Created: / 5.12.1997 / 13:43:13 / cg"
    "Modified: / 8.12.1997 / 18:51:28 / cg"
! !

!UISelectionPanel::UserDefinedGallery class methodsFor:'user spec access'!

doesNotUnderstand:aMessage
    "catch queries for a userSpec"

    |sel idx|

    ((sel := aMessage selector) startsWith:'userSpec') ifTrue:[
        idx := SelectorList indexOf:sel.
        idx ~~ 0 ifTrue:[
            ^ (HolderList at:idx) value
        ]
    ].
    ^ super doesNotUnderstand:aMessage

    "Modified: / 5.12.1997 / 14:23:24 / cg"
    "Created: / 8.12.1997 / 18:51:50 / cg"
!

respondsTo:aSelector
    "catch queries for a userSpec"

    |idx|

    (aSelector startsWith:'userSpec') ifTrue:[
        idx := Number fromString:(aSelector copyFrom:9).
        idx := SelectorList indexOf:aSelector.
        idx ~~ 0 ifTrue:[^ true].
    ].
    ^ super respondsTo:aSelector

    "Modified: / 5.12.1997 / 14:19:55 / cg"
    "Created: / 8.12.1997 / 18:51:57 / cg"
! !

!UISelectionPanel class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
UISelectionPanel initialize!
